program CuatroEnRaya1;
 
const
    (* Simbolos del tablero: blanco, jug.1, jug.2*)
    simbolo: array [0..2] of char  = (' ', 'O', 'X');
 
 
var
    tablero: array[1..8, 1..7] of integer; (* Tablero de juego*)
    terminado: boolean;
 
 
procedure DibujarTablero;
var
    fila, columna: integer;
begin
    WriteLn;
    WriteLn('-------------');
    for fila := 1 to 8 do
    begin
        Write('|');
        for columna := 1 to 7 do
            Write(' '+simbolo[tablero[fila,columna]]+' |');
        WriteLn;
        WriteLn('-------------');
    end
end;
 
 
(* ----- Pregunta donde mover y lo anota en el tablero ----- *)
procedure PreguntarPosicion( jugador: integer );  (* 1 := Jug.1, 2= Jug.2*)
var 
    fila, columna: integer;
begin   
    repeat
        WriteLn;
 
        (* Pido fila*)
        repeat
            Write('En que fila (1 a 8) ');
            ReadLn(fila);
        until fila in [1..8];
 
        (* Pido columna*)
        repeat
            Write('En que columna (1 a 7) ');
            ReadLn(columna);
        until columna in [1..7];
 
        if (tablero[fila,columna] <> 0) then
            WriteLn('Casilla ocupada!');
 
    until (tablero[fila,columna] = 0);
 
    (* Si todo es correcto, se la asigno*)
    tablero[fila,columna] := jugador;
end;
 
 
(* ----- Devuelve "true" si hay cuatro en raya ----- *)
function ComprobarGanador: boolean;
var
    hay4enRaya: boolean;
    fila, columna: integer;
begin
    hay4enRaya := false;
 
    (* Si en alguna fila todas las casillas son iguales y no vac?as*)
    for fila := 1 to 8 do
        if ((tablero[fila, 1] = tablero[fila, 2]) 
                and (tablero[fila, 1] = tablero[fila, 3])
                and (tablero[fila, 1] <> 0)) then
                if ((tablero[fila, 2] = tablero[fila, 3])
                and (tablero[fila, 2] = tablero[fila, 4])
                and (tablero[fila, 2] <> 0)) then
                if ((tablero[fila, 3] = tablero[fila, 4])
                and (tablero[fila, 3] = tablero[fila, 5])
                and (tablero[fila, 3] <> 0)) then
                if ((tablero[fila, 4] = tablero[fila, 5])
                and (tablero[fila, 4] = tablero[fila, 6])
                and (tablero[fila, 4] <> 0)) then
                if ((tablero[fila, 5] = tablero[fila, 6])
                and (tablero[fila, 5] = tablero[fila, 7])
                and (tablero[fila, 5] <> 0)) then
                if ((tablero[fila, 6] = tablero[fila, 7])
                and (tablero[fila, 6] <> 0)
                and (tablero[fila, 7] <> 0)) then

            hay4enRaya := true;
 
    (* Lo mismo para las columnas*)
    for columna := 1 to 7 do
        if ((tablero[1,columna] = tablero[2,columna])
                and (tablero[1,columna] = tablero[3,columna])
                and (tablero[1,columna] <> 0)) then
                if ((tablero[2,columna] = tablero[3,columna])
                and (tablero[2,columna] = tablero[4,columna])
                and (tablero[2,columna] <> 0)) then
                if ((tablero[3,columna] = tablero[4,columna])
                and (tablero[3,columna] = tablero[5,columna])
                and (tablero[3,columna] <> 0)) then
                if ((tablero[4,columna] = tablero[5,columna])
                and (tablero[4,columna] = tablero[6,columna])
                and (tablero[4,columna] <> 0)) then
                if ((tablero[5,columna] = tablero[6,columna])
                and (tablero[5,columna] = tablero[7,columna])
                and (tablero[5,columna] <> 0)) then
                if ((tablero[6,columna] = tablero[7,columna])
                and (tablero[6,columna] = tablero[8,columna])
                and (tablero[6,columna] <> 0)) then
                if ((tablero[7,columna] = tablero[8,columna])
                and (tablero[7,columna] <> 0)
                and (tablero[8,columna] <> 0)) then
            hay4enRaya := true;
 
    (* Y finalmente miro las diagonales*)
    if ((tablero[1, 1] = tablero[2, 2])
            and (tablero[1, 1] = tablero[3, 3])) then
            if ((tablero[2, 2] = tablero[3, 3])
            and (tablero[2, 2] = tablero[4, 4])) then
            if ((tablero[3, 3] = tablero[4, 4])
            and (tablero[3, 3] = tablero[5, 5])) then
            if ((tablero[4, 4] = tablero[5, 5])
            and (tablero[4, 4] = tablero[6, 6])) then
            if ((tablero[5, 5] = tablero[6, 6])
            and (tablero[5, 5] = tablero[7, 7])) then
            if ((tablero[6, 6] = tablero[7, 7])
            and (tablero[1, 1] <> 0))  then
            if ((tablero[2, 2] <> 0)
            and (tablero[3, 3] <> 0))  then
            if ((tablero[4, 4] <> 0)
            and (tablero[5, 5] <> 0))  then
            if ((tablero[6, 6] <> 0)
            and (tablero[7, 7] <> 0)) then

        hay4enRaya := true;

    if ((tablero[1, 7] = tablero[2, 6])
            and (tablero[1, 7] = tablero[3, 5])) then
            if ((tablero[2, 6] = tablero[3, 5])
            and (tablero[2, 6] = tablero[4, 4])) then
            if ((tablero[3, 5] = tablero[4, 4])
            and (tablero[3, 5] = tablero[5, 3])) then
            if ((tablero[4, 4] = tablero[5, 3])
            and (tablero[4, 4] = tablero[6, 2])) then
            if ((tablero[5, 3] = tablero[6, 2])
            and (tablero[5, 3] = tablero[7, 1])) then
            if ((tablero[1, 7] <> 0)
            and (tablero[2, 6] <> 0)) then
            if ((tablero[3, 5] <> 0)
            and (tablero[4, 4] <> 0)) then
            if ((tablero[5, 3] <> 0)
            and (tablero[6, 2] <> 0)) then
            if ((tablero[7, 1] <> 0)) then

        hay4enRaya := true;
 
    ComprobarGanador := hay4enRaya;
end;
 
 
(* ----- Devuelve "true" si hay empate ----- *)
function ComprobarEmpate: boolean;
var
    algunHueco: boolean;
    fila, columna: integer;
begin
    (* Si no quedan huecos donde mover, es empate*)
    algunHueco := false;
 
    for fila := 1 to 8 do
        for columna := 1 to 7 do
            if(tablero[fila,columna] = 0) then
                algunHueco := true;        
 
    ComprobarEmpate := not algunHueco;
end;
 
 
    (* ----- Cuerpo del programa ----- *)
 
 
begin
 
    begin
        terminado := false;
 
        (* Dibujar el tablero inicial*)
        DibujarTablero;
        repeat            
            (* Pedir al jugador 1*)
            PreguntarPosicion( 1 );
            (* Dibujar la casilla del jugador 1*)
            DibujarTablero;
            (* Comprobar si ha terminado la partida*)
            terminado := ComprobarGanador;
            if terminado then
                WriteLn('Gana jugador 1')
            else
                begin
                    terminado := ComprobarEmpate;
                    if terminado then
                        WriteLn('Empate!')
                    else
                    begin
                        (* Pedir al jugador 2*)
                        PreguntarPosicion( 2 );
                        (* Dibujar la casilla del jugador 2*)
                        DibujarTablero;
                        (* Comprobar si ha terminado la partida*)
                        terminado := ComprobarGanador;
                        if terminado then
                            WriteLn('Gana jugador 2');                
                    end
            end
        (* Repetir hasta 4 en raya o empate (tablero lleno)*)
        until terminado;
    end;
   readln;
end.
